<?php

// Dealwithit.gif creator

define('TMP_DIR', dirname(__FILE__).'/tmp/');
require_once('GIFEncoder.class.php');
session_start();

if (! is_dir(TMP_DIR)) {
	header('Content-Type: text/html;charset=UTF-8');
	die('<strong>'.hesc(TMP_DIR).' not a directory</strong>');
}

$GLASSES_W = 32;
$GLASSES_H = 5;

if (isset($_GET['do'])) switch($_GET['do']) {
	
	case 'upload': {
		if (count($_FILES) && array_key_exists('baseimg', $_FILES)) {
			$savename = time().'.png';
			move_uploaded_file(
				$_FILES['baseimg']['tmp_name'],
				TMP_DIR.$savename
			);
			
			$_SESSION['file'] = TMP_DIR.$savename;
			$imagesize = getimagesize(TMP_DIR.$savename);
			
			$_SESSION['params'] = array(
				'iw' => $imagesize[0],
				'ih' => $imagesize[1],
				'gx' => 50,
				'gy' => 50,
				'tx' => 30,
				'ty' => 60,
				'sz' => 'Deal with it'
			);
			header('Location: ?');
			die();
		} else {
			die('upload failed');
		}
	} break;
	
	case 'clear': {
		if (file_exists($_SESSION['file'])) {
			@unlink($_SESSION['file']);
		}
		unset($_SESSION['file']);
	} break;
	
	case 'getoriginal': {
		header('Content-Type: image/gif');
		readfile($_SESSION['file']);
		die();
	} break;
	
	case 'makegif': {
			
		header('Content-Type: image/gif');

		$rsrc = imagecreatefromjpeg('baseimg.jpg');
		$size = getimagesize('baseimg.jpg');
		
		$glasses = imagecreatefromstring(		
			"\x47\x49\x46\x38\x39\x61\x20\x00\x05\x00\x91\x00\x00\x00\x00\x00\xC3\xC3".
			"\xC3\xFF\xFF\xFF\x00\x00\x00\x21\xF9\x04\x01\x07\x00\x02\x00\x2C\x00\x00".
			"\x00\x00\x20\x00\x05\x00\x00\x02\x1D\x94\x80\xA9\xCB\xAD\x06\x51\x00\x93".
			"\x1D\x8A\x2D\xDC\x32\xBF\x3B\x55\xC9\x46\x82\x1E\xC0\x35\x65\xA9\x92\x9A".
			"\x50\x00\x00\0x3B"
		);

		$NUM_FRAMES = intval($_GET['num_frames']); //10;

		$GLASSES_DEST_X = intval($_GET['gx']); //110;
		$GLASSES_DEST_Y = intval($_GET['gy']); // 195;
		$TEXT_DEST_X = intval($_GET['tx']); //110;
		$TEXT_DEST_Y = intval($_GET['ty']); //220;
		$TEXT_STR = $_GET['text_str']; // 'Deal with it';

		$frames = array();
		$frames[] = gdtoframe($rsrc);

		for ($i = 0; $i < $NUM_FRAMES; $i++) {
			$frame = imagecreatetruecolor($size[0], $size[1]);
			imagecopy($frame, $rsrc, 0, 0, 0, 0, $size[0], $size[1]);

			$c_black = imagecolorallocate($frame, 0, 0, 0);
			$c_grey  = imagecolorallocate($frame, 182, 128, 128);
			$c_white = imagecolorallocate($frame, 255, 255, 255);
			
			imagecopyresized($frame, $glasses, $GLASSES_DEST_X, $i * ($GLASSES_DEST_Y / $NUM_FRAMES), 0, 0, $GLASSES_W*3, $GLASSES_H*3, $GLASSES_W, $GLASSES_H);
			
			if ($i == ($NUM_FRAMES - 1)) {
				imagestring($frame, 5, $TEXT_DEST_X + 1, $TEXT_DEST_Y + 1, $TEXT_STR, $c_black);
				imagestring($frame, 5, $TEXT_DEST_X, $TEXT_DEST_Y, $TEXT_STR, $c_white);
			}
			
			$frames[] = gdtoframe($frame);
		}

		// Make frame delay
		$frame_delay = array();
		for($i = 0; $i < $NUM_FRAMES; $i++) $frame_delay[] = $i;
		$frame_delay[] = 100;

		// Export image					
		$enc = new GifEncoder($frames, $frame_delay);
		echo $enc->GetAnimation();

		die();
	} break;
}

function gdtoframe($rsrc) {
	ob_start();
	imagegif($rsrc);
	return ob_get_clean();
}

function hesc($sz) {
	return htmlentities($sz, ENT_QUOTES, 'UTF-8');
}


?>
<!DOCTYPE html>
<html>
	<head>
		<meta charset="UTF-8">
		<title>dealwithit gif maker</title>
		<style type="text/css">
img {
	max-width: 100%;
}
input[type=number] {
	width:50px;
}
		</style>
	</head>
	<body>
		<h2>dealwithit gif maker</h2>
	
<?php if (! isset($_SESSION['file'])) { ?>
		<form method="POST" action="?do=upload" enctype="multipart/form-data">
			Choose image:
			<input type="file" name="baseimg">
			<input type="submit" value="Upload &raquo;">
		</form>
<?php } else { ?> 
		<a href="?do=clear">clear upload</a><br>
		<img src="?do=getoriginal">
		<form method="get">
			<input type="hidden" name="do" value="makegif">
			Glasses target: (
				<input type="number" name="gx" min="0" max="<?=hesc($_SESSION['params']['iw'] - $GLASSES_W)?>" value="<?=hesc($_SESSION['params']['gx'])?>">,
				<input type="number" name="gy" min="0" max="<?=hesc($_SESSION['params']['ih'] - $GLASSES_H)?>" value="<?=hesc($_SESSION['params']['gy'])?>">
			),
			Text target: (
				<input type="number" name="tx" min="0" max="<?=hesc($_SESSION['params']['iw'])?>" value="<?=hesc($_SESSION['params']['tx'])?>">,
				<input type="number" name="ty" min="0" max="<?=hesc($_SESSION['params']['ih'])?>" value="<?=hesc($_SESSION['params']['ty'])?>">
			),
			Text message:
			<input type="text" name="text_str" value="<?=hesc($_SESSION['params']['sz'])?>">
			Animation frames:
			<input type="number" name="num_frames" min="5" value="10">
				
			<input type="submit" value="Make gif &raquo;">
		</form>
<?php } ?> 
	</body>
</html>